<?php

namespace Drupal\synimport\Service;

use Drupal\Core\Config\FileStorage;

/**
 * Node import class.
 *
 * @internal
 *   For internal usage by the Commerce synimport module.
 */
class Node {
  /**
   * CreateEntity Service variable.
   *
   * @var CreateEntity
   */
  protected $createEntity;

  /**
   * Service constructor.
   *
   * @param Logger $log
   * @param CreateEntity $createEntity
   */
  public function __construct(Logger $log, CreateEntity $createEntity) {
    $this->log = $log;
    $this->createEntity = $createEntity;
  }

  /**
   * Import Node.
   *
   * If you need to add a custom image/gallery, attach or taxonomy field,
   *  add a new 'case' to existing ones.
   */
  public function import(string $directory) {
    $sourceNode = new FileStorage($directory);
    foreach ($sourceNode->listAll() as $file) {
      $node_array = $sourceNode->read($file);
      $node = $this->createEntity->create($node_array, 'node');
      print_r($node->id());
      if (array_key_exists('is_front', $node_array) && $node_array['is_front'] == TRUE) {
        $id = $node->id();
        $config = \Drupal::service('config.factory')->getEditable('system.site');
        $config->set('page.front', "/node/$id");
        $config->save();
      }
    }
  }

}
